using System.ComponentModel.DataAnnotations;
using System.Text.Json;

namespace View_by_Distance.Date.Group.Models.Binder;

public class Configuration
{
    [Display(Name = "By Create Date Shortcut"), Required] public bool? ByCreateDateShortcut { get; set; }
    [Display(Name = "By Date"), Required] public bool? ByDay { get; set; }
    [Display(Name = "By Hash"), Required] public bool? ByHash { get; set; }
    [Display(Name = "By Season"), Required] public bool? BySeason { get; set; }
    [Display(Name = "By Week"), Required] public bool? ByWeek { get; set; }
    [Display(Name = "Ignore Subdirectories for Rename"), Required] public bool? KeepFullPath { get; set; }
    [Display(Name = "Property Configuration"), Required] public Property.Models.Configuration? PropertyConfiguration { get; set; }

    public Configuration()
    {
        ByDay = null;
        ByCreateDateShortcut = null;
        ByHash = null;
        BySeason = null;
        ByWeek = null;
        KeepFullPath = null;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}