namespace View_by_Distance.Property.Models;

public class DirectoryInfo
{

    protected readonly FileHolder[] _SourceDirectoryFileHolderCollection;
    protected readonly string[] _FilteredSourceDirectoryFiles;
    protected readonly int _G;
    protected readonly bool[] _Moved;
    protected readonly bool?[] _Changed;
    protected readonly A_Property?[] _PropertyCollection;
    protected readonly FileInfo?[] _PropertyFileHolderCollection;
    protected readonly int _R;
    protected readonly string _SourceDirectory;
    protected readonly bool[] _ValidImageFormatExtensionCollection;
    protected readonly bool[] _WrongYear;
    public FileHolder[] SourceDirectoryFileHolderCollection => _SourceDirectoryFileHolderCollection;
    [Obsolete($"Use {nameof(SourceDirectoryFileHolderCollection)}")]
    public string[] FilteredSourceDirectoryFiles => _FilteredSourceDirectoryFiles;
    public int G => _G;
    public bool[] Moved => _Moved;
    public bool?[] Changed => _Changed;
    public A_Property?[] PropertyCollection => _PropertyCollection;
    public FileInfo?[] PropertyFileHolderCollection => _PropertyFileHolderCollection;
    public int R => _R;
    public string SourceDirectory => _SourceDirectory;
    public bool[] ValidImageFormatExtensionCollection => _ValidImageFormatExtensionCollection;
    public bool[] WrongYear => _WrongYear;

    public DirectoryInfo(int g, string sourceDirectory, string[] filteredSourceDirectoryFiles, int r)
    {
        int length = filteredSourceDirectoryFiles.Length;
        _G = g;
        _R = r;
        _Changed = Array.Empty<bool?>();
        _SourceDirectory = sourceDirectory;
        _Moved = Enumerable.Repeat(false, length).ToArray();
        _WrongYear = Enumerable.Repeat(false, length).ToArray();
        _FilteredSourceDirectoryFiles = filteredSourceDirectoryFiles;
        _PropertyCollection = Enumerable.Repeat<A_Property?>(null, length).ToArray();
        _ValidImageFormatExtensionCollection = Enumerable.Repeat(false, length).ToArray();
        _PropertyFileHolderCollection = Enumerable.Repeat<FileInfo?>(null, length).ToArray();
        _SourceDirectoryFileHolderCollection = (from l in filteredSourceDirectoryFiles select new FileHolder(l)).ToArray();
    }

}