using System.Text.Json.Serialization;
using View_by_Distance.Shared.Models;

namespace View_by_Distance.Property.Models;

public class Named
{

    protected readonly bool? _IsWrongYear;
    protected readonly DateTime _MinimumDateTime;
    protected readonly PersonBirthday? _PersonBirthday;
    protected readonly double? _PixelPercentage;
    public bool? IsWrongYear => _IsWrongYear;
    public DateTime MinimumDateTime => _MinimumDateTime;
    public PersonBirthday? PersonBirthday => _PersonBirthday;
    public double? PixelPercentage => _PixelPercentage;

    [JsonConstructor]
    public Named(bool? isWrongYear, DateTime minimumDateTime, PersonBirthday? personBirthday, double? pixelPercentage)
    {
        _IsWrongYear = isWrongYear;
        _MinimumDateTime = minimumDateTime;
        _PersonBirthday = personBirthday;
        _PixelPercentage = pixelPercentage;
    }

}