namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPerson
{

    // ...

    Dictionary<DateTime, string[]> TestStatic_Split(string knownPeopleFile);
    static Dictionary<DateTime, string[]> Split(string knownPeopleFile) => Person.Split(knownPeopleFile);

    Models.Person[] TestStatic_GetPeople(Properties.IStorage storage);
    static Models.Person[] GetPeople(Properties.IStorage storage) => Person.GetPeople(storage);

    void TestStatic_SavePerson(Properties.IStorage storage, Models.Person person);
    static void SavePerson(Properties.IStorage storage, Models.Person person) => Person.SavePerson(storage, person);

    string TestStatic_GetFileFullName(Properties.IStorage storage, Models.Person person);
    static string GetFileFullName(Properties.IStorage storage, Models.Person person) => PersonBirthday.GetFileFullName(storage, person.Birthday);

    Models.Person TestStatic_CreatePerson(Properties.IStorage storage, Models.PersonBirthday birthday, Models.PersonName name, List<Models.PersonComment> comments, List<Models.PersonURL> urls, List<Models.PersonNumber> numbers, List<Models.PersonEmail> emails, List<Models.PersonAddress> addresses);
    static Models.Person CreatePerson(Properties.IStorage storage, Models.PersonBirthday birthday, Models.PersonName name, List<Models.PersonComment> comments, List<Models.PersonURL> urls, List<Models.PersonNumber> numbers, List<Models.PersonEmail> emails, List<Models.PersonAddress> addresses) => Person.CreatePerson(storage, birthday, name, comments, urls, numbers, emails, addresses);

}